
include $(BASE)/src/aldor/Makefile.globals
include $(ALDOR_INT)/axiom/spadset.mk

domains := $(SPADSET_axiom)

# BUG! this comes from the library file
aldor_domains := lang attrib boolean0 subset axlit axextend minimach
spad_domains  := $(filter-out $(aldor_domains), $(domains))

axiom_mk_files :=   $(patsubst %,$(ALDOR_INT)/ao/%.mk, $(domains))
axiom_ap_files :=   $(patsubst %,$(ALDOR_INT)/ap/%.ap, $(domains))
axiom_ao_files :=   $(patsubst %,$(ALDOR_INT)/ao/%.ao, $(domains))
spad_ao_files  :=   $(patsubst %,$(ALDOR_INT)/ao/%.ao, $(spad_domains))
axiom_ap_files :=   $(patsubst %,$(ALDOR_INT)/ap/%.ap, $(domains))
axiom_libao_mbrs := $(patsubst %,$(ALDOR_INT)/al/libaxiom.al(%.ao), $(domains))
axiom_lst_files :=  $(patsubst %,$(ALDOR_INT)/ao/%.lst, $(domains))

spad_ap_files := $(patsubst %,$(ALDOR_INT)/ap/%.ap, $(spad_domains))

$(ALDOR_INT)/al/libaxiom.al: $(axiom_libao_mbrs)

$(axiom_mk_files): $(ALDOR_INT)/ao/%.mk: $(ALDOR_SRC)/axiom.mk.skel
	@sed -e 's/ZZZ/$*/' < $(ALDOR_SRC)/axiom.mk.skel > $@

include $(axiom_mk_files)

# spad files need to be marked specially so that axiom doesn't try to load them
$(spad_ao_files): extra_ao_options:=-Wname=axiom -Mno-abbrev -Mpreview
$(filter-out $(spad_ao_files), $(axiom_ao_files)): extra_ao_options :=
$(axiom_ao_files): $(ALDOR_INT)/ao/%.ao: $(ALDOR_INT)/ao/%.lst $(ALDOR_INT)/ap/%.ap
	@echo "AO: $* $(extra_ao_options)"
	@(  				        \
	files=$$(cat $(ALDOR_INT)/ao/$*.lst);  \
	rm -f $(ALDOR_INT)/tmp/libaxiom_$*.al;    \
	ar r $(ALDOR_INT)/tmp/libaxiom_$*.al; 	\
	for i in $$files; do ar r $(ALDOR_INT)/tmp/libaxiom_$*.al $(ALDOR_INT)/ao/$$i;	done; 	\
	cmd="aldor $(extra_ao_options) 								\
		-Y $(ALDOR_INT)/tmp -L AxiomLib=axiom_$* -fao=$@ $(ALDOR_INT)/ap/$*.ap" ;	\
	if $$cmd ; 										\
	then											\
	   rm $(ALDOR_INT)/tmp/libaxiom_$*.al;							\
	else											\
	    echo "AO Failed: $$cmd";								\
	    false;										\
	fi);

$(axiom_libao_mbrs): $(ALDOR_INT)/al/libaxiom.al(%.ao): $(ALDOR_INT)/ao/%.ao


domain_ap_files := $(patsubst %,$(ALDOR_INT)/ap/%.ap,$(domains))

#$(axiom_lst_files): $(ALDOR_INT)/ao/%.lst: $(ALDOR_INT)/java/Sort.class $(ALDOR_SRC)/extra_deps.lst
#	@echo SORT $* $(SPADSET_DEPS_axiom_$*)
#	@(cd $(ALDOR_INT); java -cp `pwd`/java Sort sort $(ALDOR_INT) $@ $(ALDOR_SRC)/extra_deps.lst $(SPADSET_DEPS_axiom_$*))

$(axiom_lst_files): $(ALDOR_OBJ)/clq/sortids
$(axiom_lst_files): $(ALDOR_INT)/ao/%.lst: $(ALDOR_INT)/java/Sort.class $(ALDOR_SRC)/extra_deps.lst
	@echo SORT $*
	@(cd $(ALDOR_INT); $(ALDOR_OBJ)/clq/sortids $(ALDOR_INT) $@ $(ALDOR_SRC)/extra_deps.lst $(SPADSET_DEPS_axiom_$*))

$(spad_ap_files): $(ALDOR_INT)/ap/%.ap: $(ALDOR_SRC)/genax.lsp $(INTERP_INT)/ax.clisp
	@echo AP: $*
	@(cd $(ALDOR_INT);  \
	  $(TOOLBIN)/mkapfile $(ALDOR_SRC) $* \
			     "$(filter-out init_%, $(SPADSET_ITEM_axiom_$*)) " \
			     "$(filter     init_%, $(SPADSET_ITEM_axiom_$*)) ")

$(axiom_libao_mbrs): $(ALDOR_INT)/al/libaxiom.al(%.ao): $(ALDOR_INT)/ao/%.ao
	@echo MBR: $*
	@ar r $(ALDOR_INT)/al/libaxiom.al $(ALDOR_INT)/ao/$*.ao


