#include "aldor"
#include "aldorio"

local main(): () == {
      args: Array String := arguments$CommandLine;
      import from MachineInteger;
      depdir:    String := args.0;
      resfile:   String := args.1;
      extradeps: String := args.2;

      tbl: HashTable(String, List String) := forget((a: String): List String +-> []);
      allNodes: Set String := [];
      nodeList: List String := [];

      for (id, dep) in extractPairs(readNames(extradeps)) repeat {
          tbl.id := cons(dep + ".ao", tbl.id);
      }

      for i in 3..(#args-1) repeat {
          id: String := copy(args.i);
stdout << "readNames: " << id << newline;
          deps: List String := readNames(depdir +  "/ao/" + (id) + ".lst");
stdout << "readNames: " << id << " " << #(deps) << deps << newline;
          deps := append!(tbl.id, copy deps);

          for dep in reverse deps repeat {
              if (not member?(dep, allNodes)) then {
                 allNodes := union(allNodes, dep);
                 nodeList := cons(dep, nodeList);
              }
          }

          if (not member?(id + ".ao", allNodes)) then {
             allNodes := union(allNodes, id + ".ao");
             nodeList := cons(id + ".ao", nodeList);
          }
      }
      writeOrder(resfile, reverse nodeList);
}


local writeOrder(fname: String, l: List String): () == {
      f: File := open(fname, fileWrite$File);
      out: TextWriter := coerce f;

      for id in l repeat {
          stdout << "out: " << id << newline;
            out << id << newline;
      }
      flush! out;
      close! f;
}

local extractPairs(l: List String): Generator Cross(String, String) ==
      generate {
          for str in l repeat {
	      r: TextReader := coerce str;
	      sb: StringBuffer := new();
	      readUntil!(sb, r, space);
	      s1: String := string(sb);
	      sb := new();
	      readWhile!(sb, r, (c: Character): Boolean +->  { not(space? c) and not (c=newline)});
	      s2: String := string(sb);
	      yield (s1, s2);
	  }
}


local readNames(fname: String): List String == {
    import from MachineInteger;
    local sb: StringBuffer;

    f: File := open(fname);
    stdout << "open: '" << fname << "'" << newline;
    rdr: TextReader := coerce f;

    ids: List String := [];
    while (readUntil!( (sb := new()), rdr, newline) = newline) repeat {
         if not empty? sb then ids := cons(string(sb), ids);
	 sb := new();
    }
    close! f;

    return ids;
}




main();

