#include "axiom"

-- Range: an interval, inclusive of start pt, exclusive of end pt
Range(X: OrderedSet): SetCategory with {
	range:   (X, X) -> %;
	bracket: (X, X) -> %;
	hi: % -> X;
	lo: % -> X;

	contains?:  (%, %) -> Boolean;
	contains?:  (%, X) -> Boolean;
} == add {
   	Rep == Record(lo: X, hi: X);
	import from Rep;

        range(lo: X, hi: X): % == per [lo, hi];
        bracket(lo: X, hi: X): % == per [lo, hi];

        (a: %) = (b: %): Boolean == lo a = lo b and hi a = hi b;

	hi(r: %): X == rep(r).hi;
	lo(r: %): X == rep(r).lo;

	contains?(r1: %, r2: %): Boolean == {
               lo r1 <= lo r2 and hi r2 <= hi r2;
        }
	
	contains?(r1: %, x: X): Boolean == {
               lo r1 <= x and x < hi r1;
        }
	
        coerce(x: %): OutputForm == {
               import from OutputForm;
               import from List OutputForm;
               import from Integer;
               bracket([coerce lo x, coerce hi x]);
        }
}


